package com.adc.da.znks.controller;

import com.adc.da.base.web.BaseController;
import com.adc.da.util.utils.UUID;
import com.adc.da.znks.entity.Device;
import com.adc.da.znks.entity.ResponseEntity;
import com.adc.da.znks.entity.User;
import com.adc.da.znks.service.DeviceService;
import com.adc.da.znks.service.UserService;
import com.adc.da.znks.util.GenResponse;
import com.adc.da.znks.vo.DeviceVO;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @author David
 */
@RestController
@RequestMapping("/api/device")
@Api(description = "| Device |")
public class DeviceController extends BaseController<Device> {

    @Autowired
    private DeviceService deviceService;

    @Autowired
    private UserService userService;

    @PostMapping("/save")
    public ResponseEntity save(DeviceVO deviceVO) {
        User user = userService.getByPhoneNumber(deviceVO.getPhoneNumber());
        try {
            deviceVO.setId(UUID.randomUUID());
            deviceVO.setUserId(user.getId());
            deviceService.insertSelective(deviceVO);
            return GenResponse.success();
        } catch (Exception e) {
            return GenResponse.fail("保存失败");
        }
    }

    @GetMapping("/getListByPhoneNumber")
    public ResponseEntity<List<Device>> getListByPhoneNumber(String phoneNumber) {
        List<Device> list = deviceService.listByPhoneNumber(phoneNumber);
        return GenResponse.success("1", "查询成功", list);
    }

    @GetMapping("/delete")
    public ResponseEntity<Boolean> delete(String id) {
        try {
            deviceService.deleteDeviceById(id);
            return GenResponse.success();
        } catch (Exception e) {
            return GenResponse.fail("删除失败");
        }
    }
}
