package com.adc.da.znks.controller;


import com.adc.da.znks.entity.Position;
import com.adc.da.znks.page.PositionPage;
import com.adc.da.znks.service.PositionService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import com.adc.da.base.web.BaseController;
import com.adc.da.util.http.PageInfo;
import com.adc.da.util.http.ResponseMessage;
import com.adc.da.util.http.Result;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;

import java.util.Date;
import java.util.List;
import java.util.UUID;

@RestController
@RequestMapping("/api/entity/positions")
@Api(description = "|Position|")
public class PositionController extends BaseController<Position> {


    @Autowired
    private PositionService positionService;

    private static final Logger logger = LoggerFactory.getLogger(PositionController.class);

//	@ApiOperation(value = "|Position|分页查询")
//    @GetMapping("/page")
//    public ResponseMessage<PageInfo<Position>> page(PositionPage page) throws Exception {
//        List<Position> rows = positionService.queryByPage(page);
//        return Result.success(getPageInfo(page.getPager(), rows));
//    }
//
//	@ApiOperation(value = "|Position|查询")
//    @GetMapping("")
//    public ResponseMessage<List<Position>> list(PositionPage page) throws Exception {
//        return Result.success(positionService.queryByList(page));
//	}
//
//    @ApiOperation(value = "|Position|详情")
//    @GetMapping("/position/{positionId}")
//    public ResponseMessage<Position> find(@PathVariable String positionId) throws Exception {
//        return Result.success(positionService.selectByPrimaryKey(positionId));
//    }

    @ApiOperation(value = "|Position|新增")
    @PostMapping("/position")
    public ResponseMessage<Boolean> create(@RequestBody Position position) throws Exception {
        position.setPositionId(UUID.randomUUID().toString());
        position.setRecordTime(new Date(System.currentTimeMillis()));
        int result = positionService.insertSelective(position);
        if (result != 0) {
            return Result.success(String.valueOf(HttpStatus.OK.value()), "新增位置成功", true);
        } else {
            return Result.error(String.valueOf(HttpStatus.OK.value()), "新增位置失败", false);
        }
    }

//    @ApiOperation(value = "|Position|修改")
//    @PutMapping("/position")
//    public ResponseMessage<Position> update(Position position) throws Exception {
//        positionService.updateByPrimaryKeySelective(position);
//        return Result.success(position);
//    }
//
//    @ApiOperation(value = "|Position|删除")
//    @DeleteMapping("/position/{positionId}")
//    public ResponseMessage delete(@PathVariable String positionId) throws Exception {
//        positionService.deleteByPrimaryKey(positionId);
//        logger.info("delete from tb_position where positionId = {}", positionId);
//        return Result.success();
//    }

}
