package com.adc.da.znks.entity;

import com.adc.da.base.entity.BaseEntity;
import com.alibaba.fastjson.annotation.JSONField;

import java.util.Date;

/**
 * <b>功能：</b>PositionEntity<br>
 */
public class Position extends BaseEntity {

    /**
     * position id
     **/
    private String positionId;

    /**
     * record position time
     **/
    @org.springframework.format.annotation.DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JSONField(format = "yyyy-MM-dd HH:mm:ss")
    private Date recordTime;

    /**
     * position name
     **/
    private String positionName;

    /**
     * app user id
     **/
    private String userId;

    public Position() {
    }

    public Position(String positionId, Date recordTime, String positionName, String userId) {
        this.positionId = positionId;
        this.recordTime = recordTime;
        this.positionName = positionName;
        this.userId = userId;
    }


    public String getPositionId() {
        return positionId;
    }

    public void setPositionId(String positionId) {
        this.positionId = positionId;
    }

    public Date getRecordTime() {
        return recordTime;
    }

    public void setRecordTime(Date recordTime) {
        this.recordTime = recordTime;
    }

    public String getPositionName() {
        return positionName;
    }

    public void setPositionName(String positionName) {
        this.positionName = positionName;
    }

    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId;
    }

    @Override
    public String toString() {
        final StringBuilder sb = new StringBuilder("{");
        sb.append("\"positionId\":\"")
                .append(positionId).append('\"');
        sb.append(",\"recordTime\":\"")
                .append(recordTime).append('\"');
        sb.append(",\"positionName\":\"")
                .append(positionName).append('\"');
        sb.append(",\"userId\":\"")
                .append(userId).append('\"');
        sb.append('}');
        return sb.toString();
    }
}
