package com.adc.da.znks.service;

import com.adc.da.base.dao.BaseDao;
import com.adc.da.base.service.BaseService;
import com.adc.da.znks.dao.DeviceDao;
import com.adc.da.znks.entity.Device;
import org.apache.ibatis.annotations.Param;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * @author David
 */
@Service
@Transactional(value = "transactionManager", propagation = Propagation.REQUIRED, rollbackFor = Throwable.class)
public class DeviceService extends BaseService<Device, String> {

    @Autowired(required = false)
    private DeviceDao dao;

    @Override
    public BaseDao<Device> getDao() {
        return dao;
    }

    public List<Device> listByPhoneNumber(String phoneNumber) {
        return dao.listByPhoneNumber(phoneNumber);
    }

    public void deleteDeviceById(String id){
        dao.deleteDeviceById(id);
    }
}
