package com.adc.da.znks.service;

import com.adc.da.base.dao.BaseDao;
import com.adc.da.base.service.BaseService;
import com.adc.da.znks.dao.GatewayDao;
import com.adc.da.znks.entity.Gateway;
import org.apache.ibatis.annotations.Param;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * @author David
 */
@Service
@Transactional(value = "transactionManager", propagation = Propagation.REQUIRED, rollbackFor = Throwable.class)
public class GatewayService extends BaseService<Gateway, String> {

    private static final Logger logger = LoggerFactory.getLogger(GatewayService.class);

    @Autowired(required = false)
    private GatewayDao dao;

    @Override
    public BaseDao<Gateway> getDao() {
        return dao;
    }

    public Boolean getByPhoneNumber(String phoneNumber) {
        boolean flag = false;
        Gateway gateway = dao.getByPhoneNumber(phoneNumber);
        if(gateway != null) {
            flag = true;
        }
        return flag;
    }

    public void updateIpByMac(Gateway gateway){
        dao.updateIpByMac(gateway);
    }

    public List<Map<String,Object>> selectIpByMac(String ip){
        return dao.selectIp(ip);
    }
}
