package com.adc.da.znks.service;

import com.adc.da.base.dao.BaseDao;
import com.adc.da.base.service.BaseService;
import com.adc.da.znks.dao.DeviceDao;
import com.adc.da.znks.dao.LockRecordDao;
import com.adc.da.znks.entity.Device;
import com.adc.da.znks.entity.LockRecord;
import org.apache.ibatis.annotations.Param;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author David
 */
@Service
@Transactional(value = "transactionManager", propagation = Propagation.REQUIRED, rollbackFor = Throwable.class)
public class LockRecordService extends BaseService<LockRecord, String> {

    @Autowired(required = false)
    private LockRecordDao dao;

    @Override
    public BaseDao<LockRecord> getDao() {
        return dao;
    }

    public void insertLockRecord(LockRecord lockRecord){
        dao.insertLockRecord(lockRecord);
    }

    public List<Map<String,Object>> selectLockRecord(String phone,String deviceCode){
        List<Map<String,Object>> result = new ArrayList<>();
        List<Map<String,Object>> list = dao.selectLockRecord(phone,deviceCode);
        List<String> dayList = new ArrayList<>();
        for(Map<String,Object> tmap : list){
            if(!dayList.contains(tmap.get("day"))){
                dayList.add(tmap.get("day").toString());
            }
        }
        for(String day : dayList){
            Map<String,Object> dayMap = new HashMap<>();
            List<Map<String,Object>> dayReList = new ArrayList<>();
            for(Map<String,Object> t : list){
                if(day.equals(t.get("day").toString())){
                    dayReList.add(t);
                }
            }
            dayMap.put("day",day);
            dayMap.put("dayList",dayReList);
            result.add(dayMap);

        }
        return result;
    }
}
