package com.adc.da.znks.util;

import com.gexin.rp.sdk.base.IPushResult;
import com.gexin.rp.sdk.base.impl.AppMessage;
import com.gexin.rp.sdk.base.impl.ListMessage;
import com.gexin.rp.sdk.base.impl.Target;
import com.gexin.rp.sdk.http.IGtPush;
import com.gexin.rp.sdk.template.NotificationTemplate;
import com.gexin.rp.sdk.template.style.Style0;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * 个推推送服务工具类
 * @author David
 */
public class AppPushUtils {

    private static String appId = "Rk3H4Z9usA6beHxyNrnIJ6";
    private static String appKey = "XRxH4VbaVZAkl7uK44pd97";
    private static String masterSecret = "xhUi7HRWsv8uj28GJdjhR2";
    private static String url = "http://sdk.open.api.igexin.com/apiex.htm";
    public static void push(String title, String msg, String clientId) throws IOException {

        // 配置返回每个用户返回用户状态，可选
        System.setProperty("gexin_pushList_needDetails", "true");
        // 配置返回每个别名及其对应cid的用户状态，可选
        // System.setProperty("gexin_pushList_needAliasDetails", "true");
        IGtPush push = new IGtPush(url, appKey, masterSecret);
        // 通知透传模板
        NotificationTemplate template = notificationTemplateDemo(title, msg);
        ListMessage message = new ListMessage();
        message.setData(template);
        // 设置消息离线，并设置离线时间
        message.setOffline(true);
        // 离线有效时间，单位为毫秒，可选
        message.setOfflineExpireTime(24 * 1000 * 3600);
        // 配置推送目标
        List<Target> targets = new ArrayList<>(1);
        Target target1 = new Target();
        target1.setAppId(appId);
        target1.setClientId(clientId);
        targets.add(target1);
        // taskId用于在推送时去查找对应的message
        String taskId = push.getContentId(message);
        IPushResult ret = push.pushMessageToList(taskId, targets);
        System.out.println(ret.getResponse().toString());
    }

    public static NotificationTemplate notificationTemplateDemo(String title, String message) {
        NotificationTemplate template = new NotificationTemplate();
        // 设置APPID与APPKEY
        template.setAppId(appId);
        template.setAppkey(appKey);

        Style0 style = new Style0();
        // 设置通知栏标题与内容
        style.setTitle(title);
        style.setText(message);
        // 配置通知栏图标
        style.setLogo("icon.png");
        // 配置通知栏网络图标
        style.setLogoUrl("");
        // 设置通知是否响铃，震动，或者可清除
        style.setRing(true);
        style.setVibrate(true);
        style.setClearable(true);
        template.setStyle(style);

        // 透传消息设置，1为强制启动应用，客户端接收到消息后就会立即启动应用；2为等待应用启动
        // template.setTransmissionType(2);
        // template.setTransmissionContent("请输入您要透传的内容");
        return template;
    }

    public static void main(String[] args) {
        try {
            push("提示", "测试推送", "59f02635c46d1b6d047fa051ad5db9fc");
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

}
