package com.adc.da.znks.util;

import org.jasypt.encryption.pbe.StandardPBEStringEncryptor;

import java.util.UUID;

/**
 * security utility class
 *
 * @author ley
 **/
public class SecurityUtils {

    //默认加密/解密算法是 PBEWithMD5AndDES
    //private static StandardPBEStringEncryptor encryptor = new StandardPBEStringEncryptor();


    /**
     * encrypt
     *
     * @param plainPassword plain password
     * @param encryptKey    encrypt key
     * @return return encrypt password
     **/
    public static String encrypt(String plainPassword, String encryptKey) {
        StandardPBEStringEncryptor encryptor = new StandardPBEStringEncryptor();
        encryptor.setPassword(encryptKey);
        return encryptor.encrypt(plainPassword);
    }


    /**
     * decrypt
     *
     * @param encryptKey encrypt key
     * @param password   encrypt password
     * @return plain password
     **/
    public static String decrypt(String encryptKey, String password) {
        StandardPBEStringEncryptor encryptor = new StandardPBEStringEncryptor();
        encryptor.setPassword(encryptKey);
        return encryptor.decrypt(password);
    }
}
