package com.adc.da.znks.util;

import java.io.DataOutputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.net.UnknownHostException;

/**
 * <pre>
 *     author : David
 *     e-mail : 990860210@qq.com
 *     time   : 2018/09/05
 *     desc   :
 *     version: 1.0
 * </pre>
 */
public class SocketUtils {



    public static String connectServerWithTCPSocket(byte[] msg, int resultLength,String host,int port) {
        String hex = null;
        Socket socket = null;
        //创建socket
        try {
            socket = new Socket(host, port);//ip+端口号
            System.out.println("socket连接成功");

            //向服务器端发送消息
            OutputStream socketWriter = socket.getOutputStream();
            System.out.println("开始发送");

            socketWriter.write(msg);
            socketWriter.flush();
            System.out.println("发送完毕，开始接收信息");

            //接收来自服务器端的消息
            InputStream socketReader = socket.getInputStream();
            byte strRxBuf[] = new byte[resultLength];
            int len = socketReader.read(strRxBuf, 0, resultLength);

            if (len != 0) {
                hex = bytesToHex(strRxBuf, 0, resultLength);
                System.out.println("接收到的byte数组的十六进制：" + hex);
                System.out.println("发送成功");
                //flag = true;
            } else {
                System.out.println("没有收到消息");
                //flag = false;
            }

            //关闭流
            socketWriter.close();
            socketReader.close();
            //关闭Socket
            socket.close();
            
        } catch (IOException e) {
            e.printStackTrace();
        }
        return hex;
    }

    /**
     * 将 byte 数组转化为十六进制字符串
     *
     * @param bytes byte[] 数组
     * @param begin 起始位置
     * @param end 结束位置
     * @return byte 数组的十六进制字符串表示
     */
    public static String bytesToHex(byte[] bytes, int begin, int end) {
        StringBuilder hexBuilder = new StringBuilder(2 * (end - begin));
        for (int i = begin; i < end; i++) {
            hexBuilder.append(Character.forDigit((bytes[i] & 0xF0) >> 4, 16)); // 转化高四位
            hexBuilder.append(Character.forDigit((bytes[i] & 0x0F), 16)); // 转化低四位
            hexBuilder.append(' '); // 加一个空格将每个字节分隔开
        }
        return hexBuilder.toString().toUpperCase();
    }

    public static void main(String[] args) {
        byte[] request = new byte[23];
        request[0] = 0x4d;
        request[1] = 0x41;
        request[2] = 0x43;
        request[3] = 0x5F;
        request[4] = 0x52;
        request[5] = 0x45;
        request[6] = 0x51;
        request[7] = 0x55;
        request[8] = 0x45;
        request[9] = 0x53;
        request[10] = 0x54;

        // 登录码
        byte[] login = new byte[8];
        login[0] = 0x2a; // 头
        login[1] = 0x01; // 第1位密码
        login[2] = 0x02; // 第2位密码
        login[3] = 0x03; // 第3位密码
        login[4] = 0x04; // 第4位密码
        login[5] = 0x05; // 第5位密码
        login[6] = 0x06; // 第6位密码
        login[7] = 0x2a; // 尾
        connectServerWithTCPSocket(login,1,"127.0.0.1",9999);

        // 门锁安防码学习
        byte[] device = new byte[8];
        device[0] = 0x54; // 校验码1：t
        device[1] = 0x59; // 校验码2：y
        device[2] = 0x54; // 校验码3：t
        device[3] = 0x01; // 识别码0x01为指纹锁
        device[4] = 0x01; // 区域码
        device[5] = 0x00; // 房间码
        device[6] = 0x00; // 设备编码
        device[7] = 0x01; // 功能码 安防码学习默认01
        //connectServerWithTCPSocket(device, 8);

        // 门锁设备码学习/ 开锁指令
        byte[] open = new byte[8];
        open[0] = 0x54; // 校验码1：t
        open[1] = 0x59; // 校验码2：y
        open[2] = 0x54; // 校验码3：t
        open[3] = 0x01; // 识别码0x01为指纹锁
        open[4] = 0x01; // 区域码
        open[5] = 0x00; // 房间码
        open[6] = 0x00; // 设备编码
        open[7] = 0x2d; // 功能码 2d:开指令/ 学习
        //connectServerWithTCPSocket(open);
    }

}
